<template>
    <div>
        <div
            class="absolute bg-black dark:bg-cgray-800 h-screen left-0 opacity-50 top-0 w-screen z-10"
        ></div>
        <div class="absolute h-screen left-0 top-0 w-screen z-20">
            <div class="h-full flex flex-col items-center justify-center">
                <div class="bg-white p-4 rounded-xl">
                    <img v-bind:src="img" style="max-height: 70vh" class="rounded-lg" />
                </div>
                <div>
                    <button v-on:click="add" class="btn-green m-4">
                        {{ this.$t('add') }}
                    </button>
                    <button v-on:click="$emit('done')" class="btn-red m-4">
                        {{ this.$t('cancel') }}
                    </button>
                </div>
            </div>
        </div>
    </div>
</template>

<script lang="ts">
    import { Component, Prop, Vue } from 'vue-property-decorator'
    import { State } from 'vuex-class'

    import html2canvas from 'html2canvas'
    import imageCompression from 'browser-image-compression'

    import { Project } from '@/ts/project'

    import Button from './Button.vue'

    @Component({
        components: {
            Button,
        },
    })
    export default class C extends Vue {
        @State('project')
        private project!: Project

        @Prop()
        private img!: string

        private mounted() {
            document.body.appendChild(this.$el)
        }

        private async add(): Promise<void> {
            if (this.project.reports.current && this.img) {
                const options = {
                    maxSizeMB: 0.5,
                    maxWidthOrHeight: 1000,
                    useWebWorker: true,
                }

                try {
                    const compressedFile = await imageCompression(
                        await imageCompression.getFilefromDataUrl(this.img, 'img.png'),
                        options
                    )

                    this.project?.reports?.current?.screenshots.push(
                        (await imageCompression.getDataUrlFromFile(compressedFile)) as string
                    )
                } catch (error) {
                    console.log(error)
                }

                this.$emit('done')
            }
        }
    }
</script>
